chiark / gitweb /
Infra: Honour archive-query-tls-curl-ca-args
[dgit.git] / tests / lib
index 776e2a3e40f42bf426365d96f2894e57795044e7..e710f39dc660f8d1d065a3c46c08d5fb93449f19 100644 (file)
--- a/tests/lib
+++ b/tests/lib
@@ -34,6 +34,8 @@ mkdir -p $tmp/gnupg
 cp $troot/gnupg/* $tmp/gnupg
 chmod go-rw $tmp/gnupg/*
 
+export DEBCHANGE_VENDOR=dpkg
+
 mkdir -p $tmp/incoming
 cat <<END >$tmp/dput.cf
 [test-dummy]
@@ -44,12 +46,60 @@ END
 
 t-expect-fail () {
        local mpat="$1"; shift
+
+       local grepper=fgrep
+       case "$mpat" in
+       [A-Z]:*)
+               case "$mpat" in
+               E:*)    grepper=egrep   ;;
+               F:*)    grepper=fgrep   ;;
+               *)      fail "bad mpat prefix in $mpat";;
+               esac
+               mpat=${mpat#[A-Z]:}
+               ;;
+       esac
+
        set +o pipefail
        LC_MESSAGES=C "$@" 2>&1 | tee $tmp/t.output
-       local gotstatus=${PIPESTATUS[0]}
+       local ps="${PIPESTATUS[*]}"
        set -o pipefail
-       test $gotstatus != 0
-       egrep "$mpat" $tmp/t.output ||false
+
+       case $ps in
+       "0 0")  fail "command unexpectedly succeeded (instead of: $mpat)" ;;
+       *" 0")  ;;
+       *)      fail "tee failed"  ;;
+       esac
+
+       $grepper -e "$mpat" $tmp/t.output ||
+               fail "error message not found"
+}
+
+t-expect-push-fail () {
+       local mpat="$1"; shift
+
+       local triedpush=`git rev-parse HEAD`
+
+       t-reporefs pre-push
+       t-expect-fail "$mpat"  "$@"
+       t-reporefs post-push
+       diff $tmp/show-refs.{pre,post}-push
+
+       t-git-objects-not-present '' $triedpush
+
+       eval "$t_expect_push_fail_hook"
+}
+
+t-git-objects-not-present () {
+       # t-git-objects-not-present GITDIR|'' OBJID [...]
+       # specifying '' means the repo for package $p
+       local gitdir="${1-$tmp/git/$p.git}"
+       local obj
+       if ! [ -e "$gitdir" ]; then return; fi
+       for obj in "$@"; do
+               GIT_DIR=$gitdir \
+               t-expect-fail 'unable to find' \
+               git cat-file -t $obj
+       done
 }
 
 t-reporefs () {
@@ -107,7 +157,7 @@ t-prep-newpackage () {
        t-git-none
        t-worktree $v
        cd $p
-       if ! git-show-ref --verify --quiet refs/heads/master; then
+       if ! git show-ref --verify --quiet refs/heads/master; then
                git branch -m dgit/sid master
                git remote rm dgit
        fi
@@ -254,6 +304,16 @@ t-clean-on-branch () {
        t-output "## $1" git status -b --porcelain
 }
 
+t-git-get-ref-exact () {
+       local ref=$1
+       # does not dereference, unlike t-git-get-ref
+       case "$ref" in
+       refs/*) ;;
+       *) fail "t-git-get-ref-exact bad $ref" ;;
+       esac
+       git for-each-ref --format='%(objectname)' "[r]efs/${ref#refs/}"
+}
+
 t-git-get-ref () {
        local ref=$1
        case "$ref" in
@@ -375,6 +435,15 @@ t-tstunt-parsechangelog () {
        t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
 }
 
+t-prep-mergechangelogs () {
+       local b=merge.dpkg-mergechangelogs
+       git config $b.name 'debian/changelog merge driver'
+       git config $b.driver 'dpkg-mergechangelogs -m %O %A %B %A'
+       mkdir -p .git/info
+       echo >>.git/info/attributes \
+               'debian/changelog merge=dpkg-mergechangelogs'
+}
+
 t-ref-dsc-dgit () {
        local dsc=${p}_${v}.dsc
        local val=`t-822-field $tmp/incoming/$dsc Dgit`
@@ -408,12 +477,16 @@ t-drs () {
  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
  t-git-config dgit-distro.test-dummy.git-check true
  t-git-config dgit-distro.test-dummy.git-create true
-       cp $root/tests/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
-       cp $root/tests/suites $tmp/.
+       cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
+       cp $troot/suites $tmp/.
 
        drs_dispatch=$tmp/distro=test-dummy
        mkdir $drs_dispatch
-       ln -sf $root $drs_dispatch/dgit-live
+
+       if [ "x$DGIT_TEST_INTREE" != x ]; then
+               ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
+       fi
+
        ln -sf $tmp/git $drs_dispatch/repos
        ln -sf $tmp/suites $tmp/dm.txt $drs_dispatch/
        mkdir -p $drs_dispatch/keyrings
@@ -443,10 +516,18 @@ t-policy-admin () {
        ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
 }
 
+t-policy-nonexist () {
+       ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
+}
+
 t-policy () {
        local policyhook=$1
-       ln -sf ${DGIT_INFRA_PFX}$policyhook \
-               $drs_dispatch/policy-hook
+       policyhook=${DGIT_INFRA_PFX}$policyhook
+       case $policyhook in
+       */*)    ;;
+       *)      policyhook=`type -P $policyhook` ;;
+       esac
+       ln -sf "$policyhook" $drs_dispatch/policy-hook
 }
 
 t-debpolicy () {